/*
Problem bralcev in pisateljev
Imamo ve bralcev, ki berejo tisto, kar zapisujejo pisatelji.
Med pisanjem enega pisatelja ne sme pisati noben drug pisatelj.
Noben pisatelj ne sme pisati med branjem.

semaforji
*/
#define HAVE_STRUCT_TIMESPEC	

#include <stdio.h>
#include <pthread.h> 
#include <windows.h>
#include <semaphore.h>

#define BRALCEV 4
#define PISATELJEV 2
#define CIKLOV_PISANJA 5

sem_t sem_pisanje;
pthread_mutex_t mutex_branje = PTHREAD_MUTEX_INITIALIZER;

int bralcev = 0;
int pisanje = 0;

void *bralec(void *par)
{
	int i = 0;
	int bralec = (int)par;

	while (pisanje == 0);
	while (1)
	{
		pthread_mutex_lock(&mutex_branje);
		bralcev++;
		if (bralcev == 1)
			sem_wait(&sem_pisanje);
		pthread_mutex_unlock(&mutex_branje);

		printf("Bralec %d: zacetek.\n", bralec);
		Sleep(1);
		printf("Bralec %d: konec.\n", bralec);

		pthread_mutex_lock(&mutex_branje);
		bralcev--;
		if (bralcev == 0)
			sem_post(&sem_pisanje);
		pthread_mutex_unlock(&mutex_branje);

		Sleep(i);
		i++;
	}
	return(NULL);
}

void *pisatelj(void *par)
{
	int i;
	int pisatelj = (int)par;

	pisanje = 1;
	for (i = 0; i<CIKLOV_PISANJA; i++)
	{
		sem_wait(&sem_pisanje);
		printf("Pisatelj %d: zacetek.\n", pisatelj);
		Sleep(1);
		printf("Pisatelj %d: konec.\n", pisatelj);
		sem_post(&sem_pisanje);
		Sleep(i);
	}
	return(NULL);
}


int main(void)
{
	int i;
	pthread_t thread_bralec[BRALCEV];
	pthread_t thread_pisatelj[PISATELJEV];

	sem_init(&sem_pisanje, 0, 1);

	for (i = 0; i<BRALCEV; i++)
		pthread_create(&thread_bralec[i], NULL, bralec, (int *)i);

	for (i = 0; i<PISATELJEV; i++)
		pthread_create(&thread_pisatelj[i], NULL, pisatelj, (int *)i);

	for (i = 0; i<PISATELJEV; i++)
		pthread_join(thread_pisatelj[i], NULL);

	sem_destroy(&sem_pisanje);
	pthread_mutex_destroy(&mutex_branje);

	return 0;
}
